use test;
go

if object_id('dbo.test', 'U') is not null
	drop table dbo.test;
go

create table dbo.test (
	i int,
	dat char(100) default(replicate('a', 100))
);
go

create nonclustered index [ix_test] on dbo.test(i);
go

insert into dbo.test (i) values (1);
go 1000

insert into dbo.test (i) values (2);
go

if object_id('dbo.test_proc', 'p') is not null
	drop procedure dbo.test_proc;
go

create procedure dbo.test_proc (
	@p int
)
as
begin
	set nocount on;

	select i, dat
	from dbo.test
	where i = @p;
end
go


exec dbo.test_proc 1;
exec dbo.test_proc 2;
go

dbcc freeproccache


exec dbo.test_proc 2;
exec dbo.test_proc 1;
go


alter procedure dbo.test_proc (
	@p int
)
as
begin
	set nocount on;

	set @p += 1

	select i, dat
	from dbo.test
	where i = @p;
end
go

exec dbo.test_proc 1;
go

alter procedure dbo.test_proc (
	@p int
)
as
begin
	set nocount on;

	select i, dat
	from dbo.test
	where i = @p
	option (recompile);
end
go


exec dbo.test_proc 2;
exec dbo.test_proc 1;
go



alter procedure dbo.test_proc (
	@p int
)
as
begin
	set nocount on;

	select i, dat
	from dbo.test
	where i = @p
	option (optimize for (@p = 1));
end
go

exec dbo.test_proc 2;

