use TEST

if object_id('dbo.payments', 'u') is not null
	drop table dbo.payments

create table dbo.payments (
	client_id int,
	payment money,
	dt datetime default (getutcdate())
)
go

insert into dbo.payments (client_id, payment)
select cast(rand(checksum(newid())) * 5 as int), rand(checksum(newid())) * 50000
go 1000

if OBJECT_ID('dbo.fn_avg_payment_by_client', N'FN') is not null
	drop function dbo.fn_avg_payment_by_client;
go

create function dbo.fn_avg_payment_by_client(@client_id int)
returns decimal(18, 2)
as
begin
	return (
		select avg(payment)
		from dbo.payments
		where client_id = @client_id
	)
end
go

-- Test
set statistics time on
set statistics io on

select p1.client_id	, p1.payment, p1.dt
from dbo.payments p1
where p1.payment < (
	select avg(p2.payment)
	from dbo.payments p2
	where p2.client_id = p1.client_id
)

select p1.client_id	, p1.payment, p1.dt
from dbo.payments p1
where p1.payment < dbo.fn_avg_payment_by_client(p1.client_id)

-- Let's see estimated execution plan