-- Like views but with parameters
use test
go

if OBJECT_ID('dbo.fn_split', N'TF') is not null
	drop function dbo.fn_split;
go

create function dbo.fn_split
(
    @str varchar(8000),
	@del char(1)
)
returns @returntable table 
(
	st varchar(8000)
)
as
begin
    
	while charindex(@del, @str) > 0
	begin
		insert into @returntable select substring(@str, 1, charindex(@del, @str) - 1)
		set @str = SUBSTRING(@str, charindex(@del, @str) + 1, len(@str))
	end
	if @str <> ''
		insert into @returntable values(@str)

	return
end
go

set statistics io on
declare @long_string varchar(8000) = 'qwe,asd,zxc,tyu,cvb,as,q,jk,z'
select * from dbo.fn_split(@long_string, ',')

if object_id('dbo.test', 'U') is not null
	drop table dbo.test;
go

create table dbo.test (
	st varchar(8000)
);
go

insert into dbo.test (st)
values
	('qwe,asd,zxc,tyu,cvb,as,q,jk,qwe,asd,zxc,tyu,cvb,as,q,jk,qwe,asd,zxc,tyu,cvb,as,q,jk,qwe,asd,zxc,tyu,cvb,as,q,jk,z'),
	('fgh,rty,lk,a,op,a,k,qw,fgh,rty,lk,a,op,a,k,qw,fgh,rty,lk,a,op,a,k,qw,fgh,rty,lk,a,op,a,k,qw,fgh,rty,lk,a,op,a,k,qw,x'),
	('fgh,rty,lk,a,op,a,k,qw,fgh,rty,lk,a,op,a,k,qw,fgh,rty,lk,a,op,a,k,qw,fgh,rty,lk,a,op,a,k,qw,fgh,rty,lk,a,op,a,k,qw,x'),
	('fgh,rty,lk,a,op,a,k,qw,fgh,rty,lk,a,op,a,k,qw,fgh,rty,lk,a,op,a,k,qw,fgh,rty,lk,a,op,a,k,qw,fgh,rty,lk,a,op,a,k,qw,x'),
	('fgh,rty,lk,a,op,a,k,qw,fgh,rty,lk,a,op,a,k,qw,fgh,rty,lk,a,op,a,k,qw,fgh,rty,lk,a,op,a,k,qw,fgh,rty,lk,a,op,a,k,qw,x'),
	('fgh,rty,lk,a,op,a,k,qw,fgh,rty,lk,a,op,a,k,qw,fgh,rty,lk,a,op,a,k,qw,fgh,rty,lk,a,op,a,k,qw,fgh,rty,lk,a,op,a,k,qw,x'),
	('afgh,frty,lck,as,oap,e,c,qqw,afgh,frty,lck,as,oap,e,c,qqw,afgh,frty,lck,as,oap,e,c,qqw,afgh,frty,lck,as,oap,e,c,qqw,aa')
go

select f.st
from dbo.test as t
cross apply dbo.fn_split(t.st, ',') as f
go


-- Rewriting fn_split
if object_id('dbo.num', 'U') is not null
	drop table dbo.num;
go

create table dbo.num (
	n int primary key clustered
);
go

declare @i int = 1

while @i < 1000
begin
	insert into dbo.num (n) values (@i)
	set @i += 1
end



if object_id('dbo.fn_split2', 'if') is not null
	drop function dbo.fn_split2;
go

create function dbo.fn_split2 (
	@str varchar(8000),
	@del char(1) = ','
) returns table
as
return
	/*with digs_cte as (
		select t1.d + t2.d * 10 + t3.d * 100 + 1 as n
		from (select 0 as d union all select 1 union all select 2 union all select 3 union all select 4 union all select 5 union all select 6 union all select 7 union all select 8 union all select 9) as t1
		cross apply (select 0 as d union all select 1 union all select 2 union all select 3 union all select 4 union all select 5 union all select 6 union all select 7 union all select 8 union all select 9) as t2
		cross apply (select 0 as d union all select 1 union all select 2 union all select 3 union all select 4 union all select 5 union all select 6 union all select 7 union all select 8 union all select 9) as t3
	)*/
	select
		substring(@str, n, case when charindex(@del, @str, n) = 0 then len(@str) else charindex(@del, @str, n) - n end) as st
	from dbo.num
	where
		n <= len(@str)
		and (n = 1 or substring(@str, n - 1, 1) = @del)
go




select f.st
from dbo.test as t
cross apply dbo.fn_split(t.st, ',') as f
go

select f.st
from dbo.test as t
cross apply dbo.fn_split2(t.st, ',') as f
go

select f.st
from (select t.st + ',' as [text()] from dbo.test as t for xml path('')) as tmp(st)
cross apply dbo.fn_split2(tmp.st, ',') as f
