-- Like views but with parameters
use test
go

if OBJECT_ID('dbo.orders', N'U') is not null
	drop table dbo.orders;
go

if OBJECT_ID('dbo.order_details', N'U') is not null
	drop table dbo.order_details;
go

create table dbo.orders (
	order_id int,
	order_date datetime default(getdate())
);
go

create table dbo.order_details (
	order_id int,
	product_id int,
	amount int
);
go

insert into dbo.orders (order_id) values (1), (2), (1), (3);
go

insert into dbo.order_details (order_id, product_id, amount)
values
	(1, 1, 1),
	(1, 2, 2),
	(2, 1, 2),
	(2, 3, 1),
	(3, 4, 5),
	(3, 5, 1);
go

if OBJECT_ID('dbo.fn_order_details', N'TF') is not null
	drop function dbo.fn_order_details;
go

create function dbo.fn_order_details
(
    @order_id int
)
returns @returntable table 
(
	product_id int,
	amount int
)
as
begin
    insert @returntable
    select product_id, amount
	from dbo.order_details
	where order_id = @order_id
    return 
end
go

set statistics io on
select *
from dbo.orders
cross apply dbo.fn_order_details(order_id)
